package com.dky.calculate;


import com.dky.entity.MatchedDevice;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicReference;

public class SchemeRating {


    public static void getOptimalScheme(List<Map<String, List<List<MatchedDevice>>>> list) {
        list.parallelStream().forEach(stringListMap -> {
            // 区分热泵、电锅炉
            stringListMap.forEach((k,v)->{
                // 循环遍历各个方案
                final Double[] maxRating = {0.0};
                v.parallelStream().forEach((plan)->{
                    AtomicReference<Double> rating = new AtomicReference<>(0.0);
                    List<Map<String, Double[]>> maps = getIndex(list);
                    for (Map<String, Double[]> map : maps) {
                        map.forEach((k1, v1) -> {
                            if (k1.equals(k)){
                                Double eff = 0.0;
                                Double cost = 0.0;
                                for (MatchedDevice device : plan) {
                                    eff = device.getDevice().getHeatingEffciency();
                                }
                                for (MatchedDevice device : plan) {
                                    cost = cost + ((device.getCount() * device.getDevice().getDevicePrice()) + (device.getCount()) * device.getDevice().getArtificialCost() * device.getDevice().getDeviceLife());
                                }
                                rating.set(((1 - ((v1[0] - eff) / v1[0])) * 100 * 0.8) + ((1 - ((cost - v1[1]) / v1[1])) * 100 * 0.2));
                                System.out.println("方案: " + plan + "，评分 = " + rating + "\n");
                            }
                        });
                    }

                });
            });
        });
    }


    public static List<Map<String, Double[]>> getIndex(List<Map<String, List<List<MatchedDevice>>>> list) {
        List<Map<String, Double[]>> maps = new ArrayList<>();
        list.parallelStream().forEach(stringListMap -> {
            // 区分热泵、电锅炉
            stringListMap.forEach((k, v) -> {
                // 循环遍历各个方案
                // 热效率、成本
                final Double[] index = {0.0, Double.MAX_VALUE};
                v.parallelStream().forEach((plan) -> {
                    Double eff = 0.0;
                    Double cost = 0.0;
                    for (MatchedDevice device : plan) {
                        eff = device.getDevice().getHeatingEffciency();
                    }
                    for (MatchedDevice device : plan) {
                        cost = cost + ((device.getCount() * device.getDevice().getDevicePrice()) + (device.getCount()) * device.getDevice().getArtificialCost() * device.getDevice().getDeviceLife());
                    }
                    if (eff >= index[0]) {
                        index[0] = eff;
                    }
                    if (cost <= index[1]) {
                        index[1] = cost;
                    }
                });
                Map<String, Double[]> map = new HashMap<>();
                map.put(k, index);
                maps.add(map);
            });
        });

        return maps;
    }




}
